diff --git a/sys/bus/u4b/input/atp.c b/sys/bus/u4b/input/atp.c
index de02b38151..b456bf97f1 100644
--- a/sys/bus/u4b/input/atp.c
+++ b/sys/bus/u4b/input/atp.c
@@ -1231,413 +1764,390 @@ atp_add_new_strokes(struct atp_softc *sc, atp_pspan *pspans_x,
 	}
 }
 
-/*
- * Advance the state of this stroke--and update the out-parameter
- * 'movement' as a side-effect.
- */
-void
-atp_advance_stroke_state(struct atp_softc *sc, atp_stroke *stroke,
-    boolean_t *movement)
+/* Initialize a stroke from an unmatched finger. */
+static void
+wsp_add_stroke(struct atp_softc *sc, const wsp_finger_t *fingerp)
 {
-	stroke->age++;
-	if (stroke->age <= atp_stroke_maturity_threshold) {
-		/* Avoid noise from immature strokes. */
-		stroke->components[X].delta_mickeys = 0;
-		stroke->components[Y].delta_mickeys = 0;
-	}
-
-	/* Revitalize stroke if it had previously been marked as a zombie. */
-	if (stroke->flags & ATSF_ZOMBIE)
-		stroke->flags &= ~ATSF_ZOMBIE;
-
-	if (atp_compute_stroke_movement(stroke))
-		*movement = TRUE;
+	atp_stroke_t *strokep;
 
-	if (stroke->type != ATP_STROKE_TOUCH)
+	strokep = atp_alloc_stroke(sc);
+	if (strokep == NULL)
 		return;
 
-	/* Convert touch strokes to slides upon detecting movement or age. */
-	if (stroke->cum_movement >= atp_slide_min_movement) {
-		atp_convert_to_slide(sc, stroke);
-	} else {
-		/* If a touch stroke is found to be older than the
-		 * touch-timeout threshold, it should be converted to
-		 * a slide; except if there is a co-incident sibling
-		 * with a later creation time.
-		 *
-		 * When multiple fingers make contact with the
-		 * touchpad, they are likely to be separated in their
-		 * times of incidence.  During a multi-finger tap,
-		 * therefore, the last finger to make
-		 * contact--i.e. the one with the latest
-		 * 'ctime'--should be used to determine how the
-		 * touch-siblings get treated; otherwise older
-		 * siblings may lapse the touch-timeout and get
-		 * converted into slides prematurely.  The following
-		 * loop determines if there exists another touch
-		 * stroke with a larger 'ctime' than the current
-		 * stroke (NOTE: zombies with a larger 'ctime' are
-		 * also considered) .
-		 */
-
-		u_int i;
-		for (i = 0; i < sc->sc_n_strokes; i++) {
-			if ((&sc->sc_strokes[i] == stroke) ||
-			    (sc->sc_strokes[i].type != ATP_STROKE_TOUCH))
-				continue;
-
-			if (timevalcmp(&sc->sc_strokes[i].ctime,
-				&stroke->ctime, >))
-				break;
-		}
-		if (i == sc->sc_n_strokes) {
-			/* Found no other touch stroke with a larger 'ctime'. */
-			struct timeval tdiff;
-
-			/* Compute the stroke's age. */
-			getmicrotime(&tdiff);
-			if (timevalcmp(&tdiff, &stroke->ctime, >))
-				timevalsub(&tdiff, &stroke->ctime);
-			else {
-				/*
-				 * If we are here, it is because getmicrotime
-				 * reported the current time as being behind
-				 * the stroke's start time; getmicrotime can
-				 * be imprecise.
-				 */
-				tdiff.tv_sec  = 0;
-				tdiff.tv_usec = 0;
-			}
+	/*
+	 * Strokes begin as potential touches. If a stroke survives
+	 * longer than a threshold, or if it records significant
+	 * cumulative movement, then it is considered a 'slide'.
+	 */
+	strokep->type    = ATP_STROKE_TOUCH;
+	strokep->matched = true;
+	microtime(&strokep->ctime);
+	strokep->age = 1;	/* number of interrupts */
+	strokep->x = fingerp->x;
+	strokep->y = fingerp->y;
+
+	/* Reset double-tap-n-drag if we have more than one strokes. */
+	if (sc->sc_n_strokes > 1)
+		sc->sc_state &= ~ATP_DOUBLE_TAP_DRAG;
 
-			if ((tdiff.tv_sec > (atp_touch_timeout / 1000000)) ||
-			    ((tdiff.tv_sec == (atp_touch_timeout / 1000000)) &&
-				(tdiff.tv_usec >=
-				    (atp_touch_timeout % 1000000))))
-				atp_convert_to_slide(sc, stroke);
-		}
-	}
+	DPRINTFN(ATP_LLEVEL_INFO, "[%d,%d]\n", strokep->x, strokep->y);
 }
 
-/* Switch a given touch stroke to being a slide. */
-void
-atp_convert_to_slide(struct atp_softc *sc, atp_stroke *stroke)
+static void
+atp_advance_stroke_state(struct atp_softc *sc, atp_stroke_t *strokep,
+    boolean_t *movementp)
 {
-	stroke->type = ATP_STROKE_SLIDE;
-
-	/* Are we at the beginning of a double-click-n-drag? */
-	if ((sc->sc_n_strokes == 1) &&
-	    ((sc->sc_state & ATP_ZOMBIES_EXIST) == 0) &&
-	    timevalcmp(&stroke->ctime, &sc->sc_reap_time, >)) {
-		struct timeval delta;
-		struct timeval window = {
-			atp_double_tap_threshold / 1000000,
-			atp_double_tap_threshold % 1000000
-		};
+	/* Revitalize stroke if it had previously been marked as a zombie. */
+	if (strokep->flags & ATSF_ZOMBIE)
+		strokep->flags &= ~ATSF_ZOMBIE;
 
-		delta = stroke->ctime;
-		timevalsub(&delta, &sc->sc_reap_time);
-		if (timevalcmp(&delta, &window, <=))
-			sc->sc_state |= ATP_DOUBLE_TAP_DRAG;
+	strokep->age++;
+	if (strokep->age <= atp_stroke_maturity_threshold) {
+		/* Avoid noise from immature strokes. */
+		strokep->instantaneous_dx = 0;
+		strokep->instantaneous_dy = 0;
 	}
-}
 
-/*
- * Terminate a stroke. While SLIDE strokes are dropped, TOUCH strokes
- * are retained as zombies so as to reap all their siblings together;
- * this helps establish the number of fingers involved in the tap.
- */
-static void
-atp_terminate_stroke(struct atp_softc *sc,
-    u_int index) /* index of the stroke to be terminated */
-{
-	atp_stroke *s = &sc->sc_strokes[index];
+	if (atp_compute_stroke_movement(strokep))
+		*movementp = true;
 
-	if (s->flags & ATSF_ZOMBIE) {
+	if (strokep->type != ATP_STROKE_TOUCH)
 		return;
-	}
 
-	if ((s->type == ATP_STROKE_TOUCH) &&
-	    (s->age > atp_stroke_maturity_threshold)) {
-		s->flags |= ATSF_ZOMBIE;
+	/* Convert touch strokes to slides upon detecting movement or age. */
+	if ((abs(strokep->cum_movement_x) > atp_slide_min_movement) ||
+	    (abs(strokep->cum_movement_y) > atp_slide_min_movement))
+		atp_convert_to_slide(sc, strokep);
+	else {
+		/* Compute the stroke's age. */
+		struct timeval tdiff;
+		getmicrotime(&tdiff);
+		if (timevalcmp(&tdiff, &strokep->ctime, >)) {
+			timevalsub(&tdiff, &strokep->ctime);
 
-		/* If no zombies exist, then prepare to reap zombies later. */
-		if ((sc->sc_state & ATP_ZOMBIES_EXIST) == 0) {
-			atp_setup_reap_time(sc, &s->ctime);
-			sc->sc_state |= ATP_ZOMBIES_EXIST;
+			if ((tdiff.tv_sec > (atp_touch_timeout / 1000000)) ||
+			    ((tdiff.tv_sec == (atp_touch_timeout / 1000000)) &&
+			     (tdiff.tv_usec >= (atp_touch_timeout % 1000000))))
+				atp_convert_to_slide(sc, strokep);
 		}
-	} else {
-		/* Drop this stroke. */
-		memcpy(&sc->sc_strokes[index], &sc->sc_strokes[index + 1],
-		    (sc->sc_n_strokes - index - 1) * sizeof(atp_stroke));
-		sc->sc_n_strokes--;
-
-		/*
-		 * Reset the double-click-n-drag at the termination of
-		 * any slide stroke.
-		 */
-		sc->sc_state &= ~ATP_DOUBLE_TAP_DRAG;
 	}
 }
 
-static __inline boolean_t
-atp_stroke_has_small_movement(const atp_stroke *stroke)
+static boolean_t
+atp_stroke_has_small_movement(const atp_stroke_t *strokep)
 {
-	return ((abs(stroke->components[X].delta_mickeys) <=
-		atp_small_movement_threshold) &&
-	    (abs(stroke->components[Y].delta_mickeys) <=
-		atp_small_movement_threshold));
+	return (((u_int)abs(strokep->instantaneous_dx) <=
+		 atp_small_movement_threshold) &&
+		((u_int)abs(strokep->instantaneous_dy) <=
+		 atp_small_movement_threshold));
 }
 
 /*
- * Accumulate delta_mickeys into the component's 'pending' bucket; if
+ * Accumulate instantaneous changes into the stroke's 'pending' bucket; if
  * the aggregate exceeds the small_movement_threshold, then retain
- * delta_mickeys for later.
+ * instantaneous changes for later.
  */
-static __inline void
-atp_update_pending_mickeys(atp_stroke_component *component)
-{
-	component->pending += component->delta_mickeys;
-	if (abs(component->pending) <= atp_small_movement_threshold)
-		component->delta_mickeys = 0;
-	else {
-		/*
-		 * Penalise pending mickeys for having accumulated
-		 * over short deltas. This operation has the effect of
-		 * scaling down the cumulative contribution of short
-		 * movements.
-		 */
-		component->pending -= (component->delta_mickeys << 1);
-	}
-}
-
-
 static void
-atp_compute_smoothening_scale_ratio(atp_stroke *stroke, int *numerator,
-    int *denominator)
+atp_update_pending_mickeys(atp_stroke_t *strokep)
 {
-	int   dxdt;
-	int   dydt;
-	u_int vel_squared; /* Square of the velocity vector's magnitude. */
-	u_int vel_squared_smooth;
-
-	/* Table holding (10 * sqrt(x)) for x between 1 and 256. */
-	static uint8_t sqrt_table[256] = {
-		10, 14, 17, 20, 22, 24, 26, 28,
-		30, 31, 33, 34, 36, 37, 38, 40,
-		41, 42, 43, 44, 45, 46, 47, 48,
-		50, 50, 51, 52, 53, 54, 55, 56,
-		57, 58, 59, 60, 60, 61, 62, 63,
-		64, 64, 65, 66, 67, 67, 68, 69,
-		70, 70, 71, 72, 72, 73, 74, 74,
-		75, 76, 76, 77, 78, 78, 79, 80,
-		80, 81, 81, 82, 83, 83, 84, 84,
-		85, 86, 86, 87, 87, 88, 88, 89,
-		90, 90, 91, 91, 92, 92, 93, 93,
-		94, 94, 95, 95, 96, 96, 97, 97,
-		98, 98, 99, 100, 100, 100, 101, 101,
-		102, 102, 103, 103, 104, 104, 105, 105,
-		106, 106, 107, 107, 108, 108, 109, 109,
-		110, 110, 110, 111, 111, 112, 112, 113,
-		113, 114, 114, 114, 115, 115, 116, 116,
-		117, 117, 117, 118, 118, 119, 119, 120,
-		120, 120, 121, 121, 122, 122, 122, 123,
-		123, 124, 124, 124, 125, 125, 126, 126,
-		126, 127, 127, 128, 128, 128, 129, 129,
-		130, 130, 130, 131, 131, 131, 132, 132,
-		133, 133, 133, 134, 134, 134, 135, 135,
-		136, 136, 136, 137, 137, 137, 138, 138,
-		138, 139, 139, 140, 140, 140, 141, 141,
-		141, 142, 142, 142, 143, 143, 143, 144,
-		144, 144, 145, 145, 145, 146, 146, 146,
-		147, 147, 147, 148, 148, 148, 149, 149,
-		150, 150, 150, 150, 151, 151, 151, 152,
-		152, 152, 153, 153, 153, 154, 154, 154,
-		155, 155, 155, 156, 156, 156, 157, 157,
-		157, 158, 158, 158, 159, 159, 159, 160
-	};
-	const u_int N = NELEM(sqrt_table);
-
-	dxdt = stroke->components[X].delta_mickeys;
-	dydt = stroke->components[Y].delta_mickeys;
-
-	*numerator = 0, *denominator = 0; /* default values. */
-
-	/* Compute a smoothened magnitude_squared of the stroke's velocity. */
-	vel_squared = dxdt * dxdt + dydt * dydt;
-	vel_squared_smooth = (3 * stroke->velocity_squared + vel_squared) >> 2;
-	stroke->velocity_squared = vel_squared_smooth; /* retained as history */
-	if ((vel_squared == 0) || (vel_squared_smooth == 0))
-		return; /* returning (numerator == 0) will imply zero movement*/
-
-	/*
-	 * In order to determine the overall movement scale factor,
-	 * we're actually interested in the effect of smoothening upon
-	 * the *magnitude* of velocity; i.e. we need to compute the
-	 * square-root of (vel_squared_smooth / vel_squared) in the
-	 * form of a numerator and denominator.
-	 */
-
-	/* Keep within the bounds of the square-root table. */
-	while ((vel_squared > N) || (vel_squared_smooth > N)) {
-		/* Dividing uniformly by 2 won't disturb the final ratio. */
-		vel_squared        >>= 1;
-		vel_squared_smooth >>= 1;
+	/* accumulate instantaneous movement */
+	strokep->pending_dx += strokep->instantaneous_dx;
+	strokep->pending_dy += strokep->instantaneous_dy;
+
+#define UPDATE_INSTANTANEOUS_AND_PENDING(I, P)                          \
+	if (abs((P)) <= atp_small_movement_threshold)                   \
+		(I) = 0; /* clobber small movement */                   \
+	else {                                                          \
+		if ((I) > 0) {                                          \
+			/*                                              \
+			 * Round up instantaneous movement to the nearest \
+			 * ceiling. This helps preserve small mickey    \
+			 * movements from being lost in following scaling \
+			 * operation.                                   \
+			 */                                             \
+			(I) = (((I) + (atp_mickeys_scale_factor - 1)) / \
+			       atp_mickeys_scale_factor) *              \
+			      atp_mickeys_scale_factor;                 \
+									\
+			/*                                              \
+			 * Deduct the rounded mickeys from pending mickeys. \
+			 * Note: we multiply by 2 to offset the previous \
+			 * accumulation of instantaneous movement into  \
+			 * pending.                                     \
+			 */                                             \
+			(P) -= ((I) << 1);                              \
+									\
+			/* truncate pending to 0 if it becomes negative. */ \
+			(P) = imax((P), 0);                             \
+		} else {                                                \
+			/*                                              \
+			 * Round down instantaneous movement to the nearest \
+			 * ceiling. This helps preserve small mickey    \
+			 * movements from being lost in following scaling \
+			 * operation.                                   \
+			 */                                             \
+			(I) = (((I) - (atp_mickeys_scale_factor - 1)) / \
+			       atp_mickeys_scale_factor) *              \
+			      atp_mickeys_scale_factor;                 \
+									\
+			/*                                              \
+			 * Deduct the rounded mickeys from pending mickeys. \
+			 * Note: we multiply by 2 to offset the previous \
+			 * accumulation of instantaneous movement into  \
+			 * pending.                                     \
+			 */                                             \
+			(P) -= ((I) << 1);                              \
+									\
+			/* truncate pending to 0 if it becomes positive. */ \
+			(P) = imin((P), 0);                             \
+		}                                                       \
 	}
 
-	*numerator   = sqrt_table[vel_squared_smooth - 1];
-	*denominator = sqrt_table[vel_squared - 1];
+	UPDATE_INSTANTANEOUS_AND_PENDING(strokep->instantaneous_dx,
+	    strokep->pending_dx);
+	UPDATE_INSTANTANEOUS_AND_PENDING(strokep->instantaneous_dy,
+	    strokep->pending_dy);
 }
 
 /*
  * Compute a smoothened value for the stroke's movement from
- * delta_mickeys in the X and Y components.
+ * instantaneous changes in the X and Y components.
  */
 static boolean_t
-atp_compute_stroke_movement(atp_stroke *stroke)
+atp_compute_stroke_movement(atp_stroke_t *strokep)
 {
-	int   num;              /* numerator of scale ratio */
-	int   denom;            /* denominator of scale ratio */
-
 	/*
 	 * Short movements are added first to the 'pending' bucket,
 	 * and then acted upon only when their aggregate exceeds a
 	 * threshold. This has the effect of filtering away movement
 	 * noise.
 	 */
-	if (atp_stroke_has_small_movement(stroke)) {
-		atp_update_pending_mickeys(&stroke->components[X]);
-		atp_update_pending_mickeys(&stroke->components[Y]);
-	} else {                /* large movement */
+	if (atp_stroke_has_small_movement(strokep))
+		atp_update_pending_mickeys(strokep);
+	else {                /* large movement */
 		/* clear away any pending mickeys if there are large movements*/
-		stroke->components[X].pending = 0;
-		stroke->components[Y].pending = 0;
+		strokep->pending_dx = 0;
+		strokep->pending_dy = 0;
 	}
 
-	/* Get the scale ratio and smoothen movement. */
-	atp_compute_smoothening_scale_ratio(stroke, &num, &denom);
-	if ((num == 0) || (denom == 0)) {
-		stroke->components[X].movement = 0;
-		stroke->components[Y].movement = 0;
-		stroke->velocity_squared >>= 1; /* Erode velocity_squared. */
-	} else {
-		stroke->components[X].movement =
-			(stroke->components[X].delta_mickeys * num) / denom;
-		stroke->components[Y].movement =
-			(stroke->components[Y].delta_mickeys * num) / denom;
-
-		stroke->cum_movement +=
-			abs(stroke->components[X].movement) +
-			abs(stroke->components[Y].movement);
+	/* scale movement */
+	strokep->movement_dx = (strokep->instantaneous_dx) /
+	    (int)atp_mickeys_scale_factor;
+	strokep->movement_dy = (strokep->instantaneous_dy) /
+	    (int)atp_mickeys_scale_factor;
+
+	if ((abs(strokep->instantaneous_dx) >= ATP_FAST_MOVEMENT_TRESHOLD) ||
+	    (abs(strokep->instantaneous_dy) >= ATP_FAST_MOVEMENT_TRESHOLD)) {
+		strokep->movement_dx <<= 1;
+		strokep->movement_dy <<= 1;
 	}
 
-	return ((stroke->components[X].movement != 0) ||
-	    (stroke->components[Y].movement != 0));
+	strokep->cum_movement_x += strokep->movement_dx;
+	strokep->cum_movement_y += strokep->movement_dy;
+
+	return ((strokep->movement_dx != 0) || (strokep->movement_dy != 0));
 }
 
-static __inline void
-atp_setup_reap_time(struct atp_softc *sc, struct timeval *tvp)
+/*
+ * Terminate a stroke. Aside from immature strokes, a slide or touch is
+ * retained as a zombies so as to reap all their termination siblings
+ * together; this helps establish the number of fingers involved at the
+ * end of a multi-touch gesture.
+ */
+static void
+atp_terminate_stroke(struct atp_softc *sc, atp_stroke_t *strokep)
 {
-	struct timeval reap_window = {
-		ATP_ZOMBIE_STROKE_REAP_WINDOW / 1000000,
-		ATP_ZOMBIE_STROKE_REAP_WINDOW % 1000000
-	};
+	if (strokep->flags & ATSF_ZOMBIE)
+		return;
+
+	/* Drop immature strokes rightaway. */
+	if (strokep->age <= atp_stroke_maturity_threshold) {
+		atp_free_stroke(sc, strokep);
+		return;
+	}
 
-	microtime(&sc->sc_reap_time);
-	timevaladd(&sc->sc_reap_time, &reap_window);
+	strokep->flags |= ATSF_ZOMBIE;
+	sc->sc_state |= ATP_ZOMBIES_EXIST;
 
-	sc->sc_reap_ctime = *tvp; /* ctime to reap */
+	usb_callout_reset(&sc->sc_callout, ATP_ZOMBIE_STROKE_REAP_INTERVAL,
+	    atp_reap_sibling_zombies, sc);
+
+	/*
+	 * Reset the double-click-n-drag at the termination of any
+	 * slide stroke.
+	 */
+	if (strokep->type == ATP_STROKE_SLIDE)
+		sc->sc_state &= ~ATP_DOUBLE_TAP_DRAG;
 }
 
-static void
-atp_reap_zombies(struct atp_softc *sc, u_int *n_reaped, u_int *reaped_xlocs)
+static boolean_t
+atp_is_horizontal_scroll(const atp_stroke_t *strokep)
 {
-	u_int       i;
-	atp_stroke *stroke;
+	if (abs(strokep->cum_movement_x) < atp_slide_min_movement)
+		return (false);
+	if (strokep->cum_movement_y == 0)
+		return (true);
+	return (abs(strokep->cum_movement_x / strokep->cum_movement_y) >= 4);
+}
+
+static boolean_t
+atp_is_vertical_scroll(const atp_stroke_t *strokep)
+{
+	if (abs(strokep->cum_movement_y) < atp_slide_min_movement)
+		return (false);
+	if (strokep->cum_movement_x == 0)
+		return (true);
+	return (abs(strokep->cum_movement_y / strokep->cum_movement_x) >= 4);
+}
 
-	*n_reaped = 0;
-	for (i = 0; i < sc->sc_n_strokes; i++) {
-		struct timeval  tdiff;
+static void
+atp_reap_sibling_zombies(void *arg)
+{
+	struct atp_softc *sc = (struct atp_softc *)arg;
+	u_int8_t n_touches_reaped = 0;
+	u_int8_t n_slides_reaped = 0;
+	u_int8_t n_horizontal_scrolls = 0;
+	u_int8_t n_vertical_scrolls = 0;
+	int horizontal_scroll = 0;
+	int vertical_scroll = 0;
+	atp_stroke_t *strokep;
+	atp_stroke_t *strokep_next;
 
-		stroke = &sc->sc_strokes[i];
+	DPRINTFN(ATP_LLEVEL_INFO, "\n");
 
-		if ((stroke->flags & ATSF_ZOMBIE) == 0)
+	TAILQ_FOREACH_MUTABLE(strokep, &sc->sc_stroke_used, entry, strokep_next) {
+		if ((strokep->flags & ATSF_ZOMBIE) == 0)
 			continue;
 
-		/* Compare this stroke's ctime with the ctime being reaped. */
-		if (timevalcmp(&stroke->ctime, &sc->sc_reap_ctime, >=)) {
-			tdiff = stroke->ctime;
-			timevalsub(&tdiff, &sc->sc_reap_ctime);
+		if (strokep->type == ATP_STROKE_TOUCH) {
+			n_touches_reaped++;
 		} else {
-			tdiff = sc->sc_reap_ctime;
-			timevalsub(&tdiff, &stroke->ctime);
-		}
-
-		if ((tdiff.tv_sec > (ATP_COINCIDENCE_THRESHOLD / 1000000)) ||
-		    ((tdiff.tv_sec == (ATP_COINCIDENCE_THRESHOLD / 1000000)) &&
-		     (tdiff.tv_usec > (ATP_COINCIDENCE_THRESHOLD % 1000000)))) {
-			continue; /* Skip non-siblings. */
+			n_slides_reaped++;
+
+			if (atp_is_horizontal_scroll(strokep)) {
+				n_horizontal_scrolls++;
+				horizontal_scroll += strokep->cum_movement_x;
+			} else if (atp_is_vertical_scroll(strokep)) {
+				n_vertical_scrolls++;
+				vertical_scroll +=  strokep->cum_movement_y;
+			}
 		}
 
-		/*
-		 * Reap this sibling zombie stroke.
-		 */
+		atp_free_stroke(sc, strokep);
+	}
 
-		if (reaped_xlocs != NULL)
-			reaped_xlocs[*n_reaped] = stroke->components[X].loc;
+	DPRINTFN(ATP_LLEVEL_INFO, "reaped %u zombies\n",
+	    n_touches_reaped + n_slides_reaped);
+	sc->sc_state &= ~ATP_ZOMBIES_EXIST;
 
-		/* Erase the stroke from the sc. */
-		memcpy(&stroke[i], &stroke[i + 1],
-		    (sc->sc_n_strokes - i - 1) * sizeof(atp_stroke));
-		sc->sc_n_strokes--;
+	/* No further processing necessary if physical button is depressed. */
+	if (sc->sc_ibtn != 0)
+		return;
 
-		*n_reaped += 1;
-		--i; /* Decr. i to keep it unchanged for the next iteration */
-	}
+	if ((n_touches_reaped == 0) && (n_slides_reaped == 0))
+		return;
 
-	DPRINTFN(ATP_LLEVEL_INFO, "reaped %u zombies\n", *n_reaped);
+	/* Add a pair of virtual button events (button-down and button-up) if
+	 * the physical button isn't pressed. */
+	if (n_touches_reaped != 0) {
+		if (n_touches_reaped < atp_tap_minimum)
+			return;
 
-	/* There could still be zombies remaining in the system. */
-	for (i = 0; i < sc->sc_n_strokes; i++) {
-		stroke = &sc->sc_strokes[i];
-		if (stroke->flags & ATSF_ZOMBIE) {
-			DPRINTFN(ATP_LLEVEL_INFO, "zombies remain!\n");
-			atp_setup_reap_time(sc, &stroke->ctime);
+		switch (n_touches_reaped) {
+		case 1:
+			atp_add_to_queue(sc, 0, 0, 0, MOUSE_BUTTON1DOWN);
+			microtime(&sc->sc_touch_reap_time); /* remember this time */
+			break;
+		case 2:
+			atp_add_to_queue(sc, 0, 0, 0, MOUSE_BUTTON3DOWN);
+			break;
+		case 3:
+			atp_add_to_queue(sc, 0, 0, 0, MOUSE_BUTTON2DOWN);
+			break;
+		default:
+			/* we handle taps of only up to 3 fingers */
 			return;
 		}
+		atp_add_to_queue(sc, 0, 0, 0, 0); /* button release */
+
+	} else if ((n_slides_reaped == 2) && (n_horizontal_scrolls == 2)) {
+		if (horizontal_scroll < 0)
+			atp_add_to_queue(sc, 0, 0, 0, MOUSE_BUTTON4DOWN);
+		else
+			atp_add_to_queue(sc, 0, 0, 0, MOUSE_BUTTON5DOWN);
+		atp_add_to_queue(sc, 0, 0, 0, 0); /* button release */
 	}
+}
 
-	/* If we reach here, then no more zombies remain. */
-	sc->sc_state &= ~ATP_ZOMBIES_EXIST;
+/* Switch a given touch stroke to being a slide. */
+static void
+atp_convert_to_slide(struct atp_softc *sc, atp_stroke_t *strokep)
+{
+	strokep->type = ATP_STROKE_SLIDE;
+
+	/* Are we at the beginning of a double-click-n-drag? */
+	if ((sc->sc_n_strokes == 1) &&
+	    ((sc->sc_state & ATP_ZOMBIES_EXIST) == 0) &&
+	    timevalcmp(&strokep->ctime, &sc->sc_touch_reap_time, >)) {
+		struct timeval delta;
+		struct timeval window = {
+			atp_double_tap_threshold / 1000000,
+			atp_double_tap_threshold % 1000000
+		};
+
+		delta = strokep->ctime;
+		timevalsub(&delta, &sc->sc_touch_reap_time);
+		if (timevalcmp(&delta, &window, <=))
+			sc->sc_state |= ATP_DOUBLE_TAP_DRAG;
+	}
+}
+
+static void
+atp_reset_buf(struct atp_softc *sc)
+{
+	/* reset read queue */
+	usb_fifo_reset(sc->sc_fifo.fp[USB_FIFO_RX]);
 }
 
+static void
+atp_add_to_queue(struct atp_softc *sc, int dx, int dy, int dz,
+    uint32_t buttons_in)
+{
+	uint32_t buttons_out;
+	uint8_t  buf[8];
 
-/* Device methods. */
-static device_probe_t  atp_probe;
-static device_attach_t atp_attach;
-static device_detach_t atp_detach;
-static usb_callback_t  atp_intr;
+	dx = imin(dx,  254); dx = imax(dx, -256);
+	dy = imin(dy,  254); dy = imax(dy, -256);
+	dz = imin(dz,  126); dz = imax(dz, -128);
 
-static const struct usb_config atp_config[ATP_N_TRANSFER] = {
-	[ATP_INTR_DT] = {
-		.type      = UE_INTERRUPT,
-		.endpoint  = UE_ADDR_ANY,
-		.direction = UE_DIR_IN,
-		.flags = {
-			.pipe_bof = 1,
-			.short_xfer_ok = 1,
-		},
-		.bufsize   = 0, /* use wMaxPacketSize */
-		.callback  = &atp_intr,
-	},
-	[ATP_RESET] = {
-		.type      = UE_CONTROL,
-		.endpoint  = 0, /* Control pipe */
-		.direction = UE_DIR_ANY,
-		.bufsize = sizeof(struct usb_device_request) + MODE_LENGTH,
-		.callback  = &atp_reset_callback,
-		.interval = 0,  /* no pre-delay */
-	},
-};
+	buttons_out = MOUSE_MSC_BUTTONS;
+	if (buttons_in & MOUSE_BUTTON1DOWN)
+		buttons_out &= ~MOUSE_MSC_BUTTON1UP;
+	else if (buttons_in & MOUSE_BUTTON2DOWN)
+		buttons_out &= ~MOUSE_MSC_BUTTON2UP;
+	else if (buttons_in & MOUSE_BUTTON3DOWN)
+		buttons_out &= ~MOUSE_MSC_BUTTON3UP;
+
+	DPRINTFN(ATP_LLEVEL_INFO, "dx=%d, dy=%d, buttons=%x\n",
+	    dx, dy, buttons_out);
+
+	/* Encode the mouse data in standard format; refer to mouse(4) */
+	buf[0] = sc->sc_mode.syncmask[1];
+	buf[0] |= buttons_out;
+	buf[1] = dx >> 1;
+	buf[2] = dy >> 1;
+	buf[3] = dx - (dx >> 1);
+	buf[4] = dy - (dy >> 1);
+	/* Encode extra bytes for level 1 */
+	if (sc->sc_mode.level == 1) {
+		buf[5] = dz >> 1;
+		buf[6] = dz - (dz >> 1);
+		buf[7] = (((~buttons_in) >> 3) & MOUSE_SYS_EXTBUTTONS);
+	}
+
+	usb_fifo_put_data_linear(sc->sc_fifo.fp[USB_FIFO_RX], buf,
+	    sc->sc_mode.packetsize, 1);
+}
 
 static int
 atp_probe(device_t self)
@@ -1647,25 +2157,58 @@ atp_probe(device_t self)
 	if (uaa->usb_mode != USB_MODE_HOST)
 		return (ENXIO);
 
-	if ((uaa->info.bInterfaceClass != UICLASS_HID) ||
-	    (uaa->info.bInterfaceProtocol != UIPROTO_MOUSE))
+	if (uaa->info.bInterfaceClass != UICLASS_HID)
 		return (ENXIO);
+	/*
+	 * Note: for some reason, the check
+	 * (uaa->info.bInterfaceProtocol == UIPROTO_MOUSE) doesn't hold true
+	 * for wellspring trackpads, so we've removed it from the common path.
+	 */
+
+	if ((usbd_lookup_id_by_uaa(fg_devs, sizeof(fg_devs), uaa)) == 0)
+		return ((uaa->info.bInterfaceProtocol == UIPROTO_MOUSE) ?
+			0 : ENXIO);
 
-	return (usbd_lookup_id_by_uaa(atp_devs, sizeof(atp_devs), uaa));
+	if ((usbd_lookup_id_by_uaa(wsp_devs, sizeof(wsp_devs), uaa)) == 0)
+		if (uaa->info.bIfaceIndex == WELLSPRING_INTERFACE_INDEX)
+			return (0);
+
+	return (ENXIO);
 }
 
 static int
 atp_attach(device_t dev)
 {
-	struct atp_softc      *sc = device_get_softc(dev);
+	struct atp_softc      *sc  = device_get_softc(dev);
 	struct usb_attach_arg *uaa = device_get_ivars(dev);
 	usb_error_t            err;
+	void *descriptor_ptr = NULL;
+	uint16_t descriptor_len;
+	unsigned long di;
 
 	DPRINTFN(ATP_LLEVEL_INFO, "sc=%p\n", sc);
 
 	sc->sc_dev        = dev;
 	sc->sc_usb_device = uaa->device;
 
+	/* Get HID descriptor */
+	if (usbd_req_get_hid_desc(uaa->device, NULL, &descriptor_ptr,
+	    &descriptor_len, M_TEMP, uaa->info.bIfaceIndex) !=
+	    USB_ERR_NORMAL_COMPLETION)
+		return (ENXIO);
+
+	/* Get HID report descriptor length */
+	sc->sc_expected_sensor_data_len = hid_report_size(descriptor_ptr,
+	    descriptor_len, hid_input, NULL);
+	kfree(descriptor_ptr, M_TEMP);
+
+	if ((sc->sc_expected_sensor_data_len <= 0) ||
+	    (sc->sc_expected_sensor_data_len > ATP_SENSOR_DATA_BUF_MAX)) {
+		DPRINTF("atp_attach: datalength invalid or too large: %d\n",
+			sc->sc_expected_sensor_data_len);
+		return (ENXIO);
+	}
+
 	/*
 	 * By default the touchpad behaves like an HID device, sending
 	 * packets with reportID = 2. Such reports contain only
@@ -1673,41 +2216,51 @@ atp_attach(device_t dev)
 	 * events,--but do not include data from the pressure
 	 * sensors. The device input mode can be switched from HID
 	 * reports to raw sensor data using vendor-specific USB
-	 * control commands; but first the mode must be read.
+	 * control commands.
 	 */
-	err = atp_req_get_report(sc->sc_usb_device, sc->sc_mode_bytes);
-	if (err != USB_ERR_NORMAL_COMPLETION) {
-		DPRINTF("failed to read device mode (%d)\n", err);
-		return (ENXIO);
-	}
-
-	if (atp_set_device_mode(dev, RAW_SENSOR_MODE) != 0) {
+	if ((err = atp_set_device_mode(sc, RAW_SENSOR_MODE)) != 0) {
 		DPRINTF("failed to set mode to 'RAW_SENSOR' (%d)\n", err);
 		return (ENXIO);
 	}
 
-	mtx_init(&sc->sc_mutex, "atpmtx", NULL, MTX_DEF | MTX_RECURSE);
+	lockinit(&sc->sc_lock, "atpmtx", 0, LK_CANRECURSE);
 
-	err = usbd_transfer_setup(uaa->device,
-	    &uaa->info.bIfaceIndex, sc->sc_xfer, atp_config,
-	    ATP_N_TRANSFER, sc, &sc->sc_mutex);
+	di = USB_GET_DRIVER_INFO(uaa);
+
+	sc->sc_family = DECODE_FAMILY_FROM_DRIVER_INFO(di);
+
+	switch(sc->sc_family) {
+	case TRACKPAD_FAMILY_FOUNTAIN_GEYSER:
+		sc->sc_params =
+		    &fg_dev_params[DECODE_PRODUCT_FROM_DRIVER_INFO(di)];
+		sc->sensor_data_interpreter = fg_interpret_sensor_data;
+		break;
+	case TRACKPAD_FAMILY_WELLSPRING:
+		sc->sc_params =
+		    &wsp_dev_params[DECODE_PRODUCT_FROM_DRIVER_INFO(di)];
+		sc->sensor_data_interpreter = wsp_interpret_sensor_data;
+		break;
+	default:
+		goto detach;
+	}
 
+	err = usbd_transfer_setup(uaa->device,
+	    &uaa->info.bIfaceIndex, sc->sc_xfer, atp_xfer_config,
+	    ATP_N_TRANSFER, sc, &sc->sc_lock);
 	if (err) {
 		DPRINTF("error=%s\n", usbd_errstr(err));
 		goto detach;
 	}
 
-	if (usb_fifo_attach(sc->sc_usb_device, sc, &sc->sc_mutex,
-		&atp_fifo_methods, &sc->sc_fifo,
-		device_get_unit(dev), 0 - 1, uaa->info.bIfaceIndex,
-		UID_ROOT, GID_OPERATOR, 0644)) {
+	if (usb_fifo_attach(sc->sc_usb_device, sc, &sc->sc_lock,
+	    &atp_fifo_methods, &sc->sc_fifo,
+	    device_get_unit(dev), -1, uaa->info.bIfaceIndex,
+	    UID_ROOT, GID_OPERATOR, 0644)) {
 		goto detach;
 	}
 
 	device_set_usb_desc(dev);
 
-	sc->sc_params           = &atp_dev_params[uaa->driver_info];
-
 	sc->sc_hw.buttons       = 3;
 	sc->sc_hw.iftype        = MOUSE_IF_USB;
 	sc->sc_hw.type          = MOUSE_PAD;
@@ -1716,17 +2269,16 @@ atp_attach(device_t dev)
 	sc->sc_mode.protocol    = MOUSE_PROTO_MSC;
 	sc->sc_mode.rate        = -1;
 	sc->sc_mode.resolution  = MOUSE_RES_UNKNOWN;
-	sc->sc_mode.accelfactor = 0;
-	sc->sc_mode.level       = 0;
 	sc->sc_mode.packetsize  = MOUSE_MSC_PACKETSIZE;
 	sc->sc_mode.syncmask[0] = MOUSE_MSC_SYNCMASK;
 	sc->sc_mode.syncmask[1] = MOUSE_MSC_SYNC;
+	sc->sc_mode.accelfactor = 0;
+	sc->sc_mode.level       = 0;
 
 	sc->sc_state            = 0;
+	sc->sc_ibtn             = 0;
 
-	sc->sc_left_margin  = atp_mickeys_scale_factor;
-	sc->sc_right_margin = (sc->sc_params->n_xsensors - 1) *
-		atp_mickeys_scale_factor;
+	usb_callout_init_mtx(&sc->sc_callout, &sc->sc_lock, 0);
 
 	return (0);
 
@@ -1741,17 +2293,19 @@ atp_detach(device_t dev)
 	struct atp_softc *sc;
 
 	sc = device_get_softc(dev);
-	if (sc->sc_state & ATP_ENABLED) {
-		mtx_lock(&sc->sc_mutex);
+	atp_set_device_mode(sc, HID_MODE);
+
+	lockmgr(&sc->sc_lock, LK_EXCLUSIVE);
+	usb_callout_drain(&sc->sc_callout);
+	if (sc->sc_state & ATP_ENABLED)
 		atp_disable(sc);
-		mtx_unlock(&sc->sc_mutex);
-	}
+	lockmgr(&sc->sc_lock, LK_RELEASE);
 
 	usb_fifo_detach(&sc->sc_fifo);
 
 	usbd_transfer_unsetup(sc->sc_xfer, ATP_N_TRANSFER);
 
-	mtx_destroy(&sc->sc_mutex);
+	lockuninit(&sc->sc_lock);
 
 	return (0);
 }
